/*
 * protocol.c: demonstrates the 1-wire protocol of the dht11
 *
 * copyright U. Raich Dec 2016
 */

#include <stdio.h>
#include <wiringPi.h>
#define GPIO_PIN 0

int main(int argc, char ** argv) {
  int protoData[800],*dataPtr;
  int i;
  
  wiringPiSetup();
  pinMode(GPIO_PIN,OUTPUT);
  
  printf("Raspberry Pi read DHT11 protocol\n");
/* start the dht11 by pulling the data line down for 18 ms 
   and then high for 18 us
*/
  dataPtr = protoData;
  digitalWrite(GPIO_PIN,0);
  delay(18);
  digitalWrite(GPIO_PIN,1);
  delayMicroseconds(40);

  /* switch the GPIO pin to input and read the data every 5 us */
  pinMode(GPIO_PIN,INPUT);
  for (i=0;i<800;i++){
    *dataPtr++ = digitalRead(GPIO_PIN);
    delayMicroseconds(5);
  }
  dataPtr = protoData;
  for (i=0;i<800;i++)
    printf("%d\n",*dataPtr++);
}
